#include "track.h"
#include <fstream>

TrackList::TrackList (char *FileName, AlbumList &AL)
: Albums (AL)
{
  ifstream s (FileName);
  try  { for (;;) Tracks.push_back (s); }
  catch (EOFException) {}
  for (unsigned i = 0; i < Tracks.size (); i ++)
    Tracks[i].LookupAlbum (AL);
}

struct TrackOrder
{ bool operator() (const Track *A, const Track *B) const
  { return *A < *B; }
};

void TrackList::Print (ostream &o) const
{
  set<const Track *, TrackOrder> TS;
  for (unsigned i = 0; i < Tracks.size (); i ++)
    TS.insert (&Tracks[i]);
  const Album *A = 0;
  for (set<const Track *, TrackOrder>::iterator i = TS.begin (); i != TS.end (); i ++)
  { if ((*i)->GetAlbum () != A)
    { A = (*i)->GetAlbum ();  o << *A; }
    o << **i;
  }
}
