#include <stdio.h>
#include <stdlib.h>
#include "album.h"

AlbumList *NewAlbumList ()
{
  AlbumList *AL = (AlbumList *) malloc (sizeof (AlbumList));
  AL->Count = 0;
  AL->Allocated = 10;
  AL->Albums = (Album **) calloc (AL->Allocated, sizeof (Album *));
  return AL;
}

void DeleteAlbumList (AlbumList *AL)
{
  int i;
  for (i = 0; i < AL->Count; i ++)  free (AL->Albums[i]);
  free (AL->Albums);
  free (AL);
}

Album *NewAlbum (AlbumList *AL)
{
  if (AL->Count >= AL->Allocated)
  { AL->Allocated *= 2;
    AL->Albums = (Album **) realloc (AL->Albums, AL->Allocated * sizeof (Album *));
  }
  Album *A = (Album *) malloc (sizeof (Album));
  AL->Albums[AL->Count++] = A;
  return A;
}

void ReadAlbumList (AlbumList *AL, char *FileName)
{
  FILE *File = fopen (FileName, "r");
  if (File == NULL)  { perror (FileName);  exit (1); }
  int r, Id;
  do
  {
    r = fscanf (File, "%d", &Id);
    if (r != EOF)
    {
      Album *A = NewAlbum (AL);
      A->Id = Id;
      r = fscanf (File, "%100s %100s %d", A->Title, A->Artist, &A->Year);
      StringSubst (A->Title, '_', ' ');
      StringSubst (A->Artist, '_', ' ');
    }
  }
  while (r != EOF);
  fclose (File);
}

Album *FindAlbum (AlbumList *AL, int Id)
{
  int i;
  for (i = 0; i < AL->Count; i ++)
    if (AL->Albums[i]->Id == Id)
      return (AL->Albums[i]);
  fprintf (stderr, "Album Id %d not found\n", Id);
  exit (1);
}

void PrintAlbum (Album *A)
{
  printf ("%s (%s, %d)\n", A->Title, A->Artist, A->Year);
}

void StringSubst (char *s, char old, char new)
{
  while (*s) { if (*s == old) *s = new; s ++; }
}
